//
//  TESTProgressView.m
//
//  Created by Thomas Wolters on 19/10/15.
//  Copyright © 2015 fluodmobile. All rights reserved.
//
#import "Demo0AnimationLayerView.h"

#define DURATION 0.5

#define INIT_scaleX 1.0f
#define INIT_cornerRadius 4

@interface Demo0AnimationLayerView()
@property (nonatomic, strong) CAShapeLayer* layerSeed;
@property (nonatomic, strong) UITableView* tableView;

@end

@implementation Demo0AnimationLayerView
- (instancetype)init{
    self = [super init];
    if (!self) {
        return nil;
    }
    self.backgroundColor = [UIColor lightGrayColor];

    //setup layer
    self.layerSeed = [CAShapeLayer new];
    self.layerSeed.backgroundColor = [UIColor redColor].CGColor;
    [self.layer addSublayer:self.layerSeed];;
    
    //setup tableView for configuration
    self.tableView = [UITableView new];
    self.tableView.backgroundColor = [UIColor lightGrayColor];
    [self addSubview:self.tableView];
    
    //set initial values
    self.scaleX = INIT_scaleX;

    return self;
}



-(void)setCornerRadius:(float)cornerRadius{
    _cornerRadius = cornerRadius;
    [self setNeedsLayout];
}

-(void)layoutSubviews{
    [super layoutSubviews];
    float elementDimension = 10;
    float heightSeedArea = 200;
    self.layerSeed.frame = (CGRect) {self.frame.size.width/2,(heightSeedArea-elementDimension)/2,elementDimension,elementDimension};
    self.layerSeed.cornerRadius = self.cornerRadius;

    self.tableView.frame = (CGRect){0,heightSeedArea,self.bounds.size.width,self.bounds.size.height-heightSeedArea};
}

-(void)resetValues{
    self.scaleX = INIT_scaleX;
    self.cornerRadius = INIT_cornerRadius;
}

-(void)loadScenarioPulseValues{
    self.scaleX = 10.0f;
}
@end
