//
//  TESTProgressViewController.m
//
//  Created by Thomas Wolters on 19/10/15.
//  Copyright © 2015 fluodmobile. All rights reserved.
//

#import "Demo0AnimationLayerViewController.h"
#import "Demo0AnimationLayerView.h"
#import "TESTSliderCell.h"
#import "TESTButtonCell.h"


@interface Demo0AnimationLayerViewController () <UITableViewDelegate, UITableViewDataSource, TESTSliderCellDelegate>
@property (nonatomic, strong) Demo0AnimationLayerView* viewProgress;
@end

@implementation Demo0AnimationLayerViewController

-(void)loadView{
    self.viewProgress = [Demo0AnimationLayerView new];
    self.view = self.viewProgress;
}

- (void)viewDidLoad {
    [super viewDidLoad];
    self.viewProgress.tableView.delegate = self;
    self.viewProgress.tableView.dataSource = self;
    [self.viewProgress.tableView registerClass:[TESTSliderCell class] forCellReuseIdentifier:CELL_SLIDER];
    [self.viewProgress.tableView registerClass:[TESTButtonCell class] forCellReuseIdentifier:CELL_BUTTON];
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section{
    switch (section) {
        case 0:
            return 2;
        case 1:
            return 1;
    }
    return 0;
}

-(NSInteger)numberOfSectionsInTableView:(UITableView *)tableView{
    return 2;
}

- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath{
    switch (indexPath.section) {
        case 0:
            return CELL_SLIDER_HEIGHT;
        case 1:
            return CELL_BUTTON_HEIGHT;
    }
    return CELL_SLIDER_HEIGHT;
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath{
    switch (indexPath.section) {
        case 0:{
            TESTSliderCell* cell = [tableView dequeueReusableCellWithIdentifier:CELL_SLIDER];
            cell.delegate = self;
            switch (indexPath.row) {
                case 0:
                    [cell setAttribute:@"scaleX" value:self.viewProgress.scaleX minValue:1.0f maxValue:5 index:indexPath.row];
                    break;

                case 1:
                    [cell setAttribute:@"Corner Radius" value:self.viewProgress.cornerRadius minValue:0.0f maxValue:10 index:indexPath.row];
                    break;
                default:
                    break;
            }
            return cell;
        }
            break;
        case 1:{
            TESTButtonCell* cell = [tableView dequeueReusableCellWithIdentifier:CELL_BUTTON];
            switch (indexPath.row) {
                case 0:
                    [cell setTitle:@"Reset" scenario:TESTAnimationScenarioDefault];
                    break;
                default:
                    break;
            }
            return cell;
        }
            break;
        default:
            break;
    }
    return nil;
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath{
    [tableView deselectRowAtIndexPath:indexPath animated:YES];
    switch (indexPath.section) {
        case 1:
            switch (indexPath.row) {
                case 0:
                    [self loadView];
                    [self viewDidLoad];
                    [self viewDidAppear:YES];
                    break;
                default:
                    break;
            }
            break;
        default:
            break;
    }
}

-(void)userDidSelectValue:(float)value attribute:(NSString*)attribute index:(long)index{
    switch (index) {
        case 0:
            self.viewProgress.scaleX = value;
            break;

        case 1:
            self.viewProgress.cornerRadius = value;
            break;
        default:
            break;
    }
}

@end
