//
//  TESTBurningBottomView.m
//
//  Created by Thomas Wolters on 22/10/15.
//  Copyright © 2015 fluodmobile. All rights reserved.
//

#import "TESTBurningBottomView.h"
@interface TESTBurningBottomView()


@end
@implementation TESTBurningBottomView

- (instancetype)init{
    self = [super init];
    if (!self) {
        return nil;
    }
    
    self.backgroundColor = [UIColor clearColor];

    
    
    
    return self;
}

-(void)layoutSubviews{
    [super layoutSubviews];
        [self setSmokeLevel:200];
}

-(void)setSmokeLevel:(float)level{
    if (!self.fireEmitter){
        // Create the emitter layers
        self.fireEmitter	= [CAEmitterLayer layer];
        self.smokeEmitter	= [CAEmitterLayer layer];
        
        
        
        float height = 10;
        CGPoint emitterposition = CGPointMake(self.bounds.size.width/2,self.bounds.size.height+height/2);
        CGSize emitterSize = CGSizeMake(self.bounds.size.width, height);
        
        self.fireEmitter.emitterPosition = emitterposition;
        self.fireEmitter.emitterSize	= emitterSize;
        self.fireEmitter.emitterMode	= kCAEmitterLayerOutline;
        self.fireEmitter.emitterShape	= kCAEmitterLayerLine;
        // with additive rendering the dense cell distribution will create "hot" areas
        self.fireEmitter.renderMode		= kCAEmitterLayerAdditive;
        
        self.smokeEmitter.emitterPosition = emitterposition;
        self.smokeEmitter.emitterSize	= emitterSize;
        self.smokeEmitter.emitterMode	= kCAEmitterLayerOutline;
        self.smokeEmitter.emitterShape	= kCAEmitterLayerLine;
        
        self.smokeEmitter.emitterCells	= [NSArray arrayWithObject:[self cellSmoke]];
        self.fireEmitter.emitterCells	= [NSArray arrayWithObject:[self cellFire]];
        
        [self.layer addSublayer:self.fireEmitter];
        [self.layer addSublayer:self.smokeEmitter];
        
        //        self.fireEmitter.backgroundColor = [UIColor redColor].CGColor;
        self.fireEmitter.frame = self.bounds;
    }
    
    float zeroToOne = level/20.0;
    //    zeroToOne = 0.9f;
    
    // Update the fire properties
    [self.fireEmitter setValue:[NSNumber numberWithInt:(zeroToOne * 500)] forKeyPath:@"emitterCells.fire.birthRate"];
    [self.fireEmitter setValue:[NSNumber numberWithFloat:zeroToOne] forKeyPath:@"emitterCells.fire.lifetime"];
    [self.fireEmitter setValue:[NSNumber numberWithFloat:(zeroToOne * 0.35)] forKeyPath:@"emitterCells.fire.lifetimeRange"];
    //    self.fireEmitter.emitterSize = CGSizeMake(50 * 1, 0);
    
    [self.smokeEmitter setValue:[NSNumber numberWithInt:zeroToOne * 4] forKeyPath:@"emitterCells.smoke.lifetime"];
    [self.smokeEmitter setValue:(id)[[UIColor colorWithRed:1 green:1 blue:1 alpha:zeroToOne * 0.3] CGColor] forKeyPath:@"emitterCells.smoke.color"];
    
}

-(CAEmitterCell*)cellFire{
    CAEmitterCell* fire = [CAEmitterCell emitterCell];
    [fire setName:@"fire"];
    fire.birthRate			= 100;
    fire.emissionLongitude  = M_PI;
    fire.velocity			= -80;
    fire.velocityRange		= 30;
    fire.emissionRange		= 1.1;
    fire.yAcceleration		= -200;
    fire.scaleSpeed			= 0.3;
    fire.lifetime			= 50;
    fire.lifetimeRange		= (50.0 * 0.35);
    fire.color = [[UIColor colorWithRed:0.8 green:0.4 blue:0.2 alpha:0.1] CGColor];
    fire.contents = (id) [[UIImage imageNamed:@"fire"] CGImage];
    return fire;
}

-(CAEmitterCell*)cellSmoke{
    // Create the smoke emitter cell
    CAEmitterCell* smoke = [CAEmitterCell emitterCell];
    [smoke setName:@"smoke"];
    
    smoke.birthRate			= 11;
    smoke.emissionLongitude = -M_PI / 2;
    smoke.lifetime			= 10;
    smoke.velocity			= -40;
    smoke.velocityRange		= 20;
    smoke.emissionRange		= M_PI / 4;
    smoke.spin				= 1;
    smoke.spinRange			= 6;
    smoke.yAcceleration		= -160;
    smoke.contents			= (id) [[UIImage imageNamed:@"smoke"] CGImage];
    smoke.scale				= 0.1;
    smoke.alphaSpeed		= -0.12;
    smoke.scaleSpeed		= 0.7;
    return smoke;
}

@end
